/// <reference types="@emotion/core" />
import { TreeView, IFilter, ISort, TreeNode, InsertSiblingType, IData } from './node';
export interface IUseTreeState {
    id: string;
    data: any;
    filter?: IFilter;
    sort?: ISort;
    defaultOpened?: boolean | number[];
    multipleSelect?: boolean;
    idKey?: string;
    childrenKey?: string;
}
export declare type IDropType = 'before' | 'children' | 'after';
export declare const useTreeState: ({ id, data, filter, sort, defaultOpened, multipleSelect, idKey, childrenKey, }: IUseTreeState) => {
    instance: TreeView;
    handlers: {
        setChildren: (parent: string | number | TreeNode, children: TreeNode[], type?: "first" | "last" | undefined, reset?: boolean | undefined) => void;
        setLoading: (node: string | number | TreeNode, loading?: boolean | undefined) => void;
        setOpen: (node: string | number | TreeNode) => void;
        setRawChildren: (parent: string | number | TreeNode, children: IData[], type?: "first" | "last" | undefined, reset?: boolean | undefined) => void;
        setSelected: (node: string | number | TreeNode, selected?: boolean | undefined) => void;
        setSiblings: (node: string | number | TreeNode, siblings: TreeNode[], type: InsertSiblingType) => void;
        draggableHandlers: {
            handleDragStart: (e: import("react").DragEvent<Element>) => void;
            handleDragEnter: (node: TreeNode, type: string | boolean) => (e: import("react").DragEvent<Element>) => void;
            handleDragLeave: (node: TreeNode) => (e: import("react").DragEvent<Element>) => void;
            handleDrop: (sourceNode: TreeNode) => (e: import("react").DragEvent<Element>) => void;
        };
    };
    required: {
        isDragging: boolean;
        data: TreeNode[];
    };
};
